﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication5
{
    class Program
    {
        static void Main(string[] args)
        {
            CompactarMdb("C:\\Users\\André\\Desktop\\Database1.mdb");
        }

        public static void CompactarMdb(string caminhoMdb)
        {
            try
            {
                JRO.JetEngine jetEngine = (JRO.JetEngine)Activator.CreateInstance(Type.GetTypeFromProgID("JRO.JetEngine"));
                var arquivoTemporario = System.IO.Path.GetTempFileName();
                arquivoTemporario = System.IO.Path.ChangeExtension(arquivoTemporario, "mdb");
                string templateConnectionString = "Data Source={0};Provider=Microsoft.Jet.OLEDB.4.0;";
                string connectionStringFonte = string.Format(templateConnectionString, caminhoMdb);
                string connectionStringTemp = string.Format(templateConnectionString, arquivoTemporario);

                jetEngine.CompactDatabase(connectionStringFonte, connectionStringTemp);
                System.IO.File.Copy(arquivoTemporario, caminhoMdb, true);
                System.IO.File.Delete(arquivoTemporario);
            }
            catch { }
        }

    }
}
